''  *** COMPILED WITH PropBasic VERSION 00.00.73  Jan 21, 2010 ***
                                                             '' PropSound_C.pbas 
                                                             '' CWE 19.01.10
                                                             '' parts from Soundmeter SndMeter.pb
                                                             '' 20.01.10: ADC and DAC with Reverb as Task
                                                             ''           Zero as Center
                                                             '' 21.01.10: Distortion
                                                             ''           Compressor
                                                             '' 22.01.10: Distortion with abs maximum
                                                             ''           Echo added
                                                             '' 23.01.10: Starttext added

                '           ASM                              'asm 

{ Starting a multiline comment                              
#############################################################################################
                                                            
This Soundprocessor for guitars works with Propbasic.       
Propbasic gives enough performance for calculations between samples!
The software runs on a protoboard. It can be tried with the onboard microphone.
                                                            
The sample rate and therefore bandwidth is limited.         
This gives higher adc bit resolution (sigma delta) and      
gives more time for calculations between samples.           
The time for echo delay can be longer with the onboard RAM. 
The onboard RAM and the onboard adc and dac possibilities are used.
                                                            
cog0 starts cogs                                            
cog1 user interface (not yet implemented)                   
                                                            
cog2 adc and dac with reverb                                
cog3 ... cog7 for sound modules                             
                                                            
The sound is passed through the modules through the global variables sslot(0..7).
A changement in the globalvariable "SampleNo" signals, that there is a new sample for processing.
                                                            
                                                            
At the moment, the parameters for the sounds (mostly in percent values 0...99) are given as
start values of variables. Have a look at the beginnings of the tasks.
                                                            
Compressor, Reverb, Distortion, and Echo are implemented at the moment.
                                                            
##############################################################################################
}                                                           
                '           ENDASM                           'endasm

                                                             ''


CON                                                          'DEVICE P8X32A, XTAL1, PLL16X
  _ClkMode = XTAL1 + PLL16X                                 

  _XInFreq =   5000000                                       'FREQ 80_000_000



                                                             '' Define CONs
' Baud          =  "T115200"                                 'Baud       CON "T115200"

' POSFB    CON 72      ' Counter mode for POS detect with feedback 'POSFB    CON 72      ' Counter mode for POS detect with feedback

' ADCVALUE CON 8192    ' Maximum value of ADC 4096 ergibt ca 19.5kHz 'ADCVALUE CON 8192    ' Maximum value of ADC 4096 ergibt ca 19.5kHz

' AMPLITUDE CON 4096                                         'AMPLITUDE CON 4096

' MaxAmpl    CON 4000                                        'MaxAmpl    CON 4000

' MaxNegAmpl CON -4000                                       'MaxNegAmpl CON -4000

' EBufLen CON 7_000 'Length of Echobuffer                    'EBufLen CON 7_000 'Length of Echobuffer

' RBUFLEN CON 2_500 'Length of Reverbbuffer                  'RBUFLEN CON 2_500 'Length of Reverbbuffer

' SinLen CON 35 '70 'words                                   'SinLen CON 35 '70 'words

' ConSt2 CON 2 'for signed divisor?                          'ConSt2 CON 2 'for signed divisor?









                                                             '' Define PINs
' TX          PIN 30 HIGH   ' Send data back to PC           'TX          PIN 30 HIGH   ' Send data back to PC

                                                             ''MicFB    PIN 4 INPUT      'Pins for Guitar Input
                                                             ''MicOut   PIN 3 OUTPUT
' MicFB    PIN 8 INPUT     'Pins of the Micro on the demo board 'MicFB    PIN 8 INPUT     'Pins of the Micro on the demo board

' MicOut   PIN 9 OUTPUT                                      'MicOut   PIN 9 OUTPUT

' LEDs     PIN 16..21 LOW                                    'LEDs     PIN 16..21 LOW

' LED1     PIN 23 LOW                                        'LED1     PIN 23 LOW


' RightChan PIN 10 OUTPUT                                    'RightChan PIN 10 OUTPUT

' LeftChan  PIN 11 OUTPUT                                    'LeftChan  PIN 11 OUTPUT



                                                             '' Define HUB variables
' VAR WORD EBuf[7000]                                        'EBuf HUB word(EBufLen)=0

' VAR WORD RBuf[2500]                                        'RBuf HUB word(RBUFLEN)=0 'Reverb Buffer

' VAR WORD SSlot[8]                                          'SSlot HUB word(8)=0      'Sound Slots to pass data

' VAR LONG SampleNo                                          'SampleNo HUB long = 0

' VAR LONG debug                                             'debug HUB long =0



                                                             '' Define DATA (DATA, WDATA, LDATA)
'SinTab WDATA 0 ,       695     ,       1368    ,       2000    ,       2571    ,       3064    ,       3464    ,       3759    ,       3939  'SinTab WDATA 0   ,       695     ,       1368    ,       2000    ,       2571    ,       3064    ,       3464    ,       3759    ,       3939

' wdata 4000    ,       3939    ,       3759    ,       3464    ,       3064    ,       2571    ,       2000    ,       1368    ,       695  ' wdata 4000       ,       3939    ,       3759    ,       3464    ,       3064    ,       2571    ,       2000    ,       1368    ,       695

' wdata 0       ,       -695    ,       -1368   ,       -2000   ,       -2571   ,       -3064   ,       -3464   ,       -3759   ,       -3939  ' wdata 0        ,       -695    ,       -1368   ,       -2000   ,       -2571   ,       -3064   ,       -3464   ,       -3759   ,       -3939

' wdata -4000   ,       -3939   ,       -3759   ,       -3464   ,       -3064   ,       -2571   ,       -2000   ,       -1368   ,       -695  ' wdata -4000     ,       -3939   ,       -3759   ,       -3464   ,       -3064   ,       -2571   ,       -2000   ,       -1368   ,       -695




                                                             ''###############################################################################################

                                                             '' Define TASKs
OBJ ADDAC_Reverb: "ADDAC_Reverb.spin"                        'ADDAC_Reverb TASK

OBJ Gen_Sinus: "Gen_Sinus.spin"                              'Gen_Sinus TASK

OBJ Distortion: "Distortion.spin"                            'Distortion TASK

OBJ Compressor: "Compressor.spin"                            'Compressor TASK

OBJ Echo: "Echo.spin"                                        'Echo TASK



                                                             '' Define variables (LONGs only)
' temp     VAR LONG                                          'temp     VAR LONG

' ascii    VAR LONG(13) ' Conversion to ASCII                'ascii    VAR LONG(13) ' Conversion to ASCII

' i        var long                                          'i        var long

' y        var long                                          'y        var long

' amplchar var long =40                                      'amplchar var long =40

' mamplchar var long =-40                                    'mamplchar var long =-40


                                                             '' Define Subroutines
' SerNumber SUB 1                                            'SerNumber SUB 1

' Stars     sub 2                                            'Stars     sub 2


                                                             ''###############################################################################################
                                                             '' Start of main code
PUB __Program                                                'PROGRAM Start
  ADDAC_Reverb_COG:=ADDAC_Reverb.Init(@__DATASTART)         
  Gen_Sinus_COG:=Gen_Sinus.Init(@__DATASTART)               
  Distortion_COG:=Distortion.Init(@__DATASTART)             
  Compressor_COG:=Compressor.Init(@__DATASTART)             
  Echo_COG:=Echo.Init(@__DATASTART)                         
  CogInit(0, @__Init, @__DATASTART)                         
                                                            
DAT                                                         
                org         0                               
__Init                                                      
                mov         dira,__InitDirA                 
                mov         outa,__InitOutA                 
                jmp         #Start                          

Start                                                        'Start:

                mov         __temp1,#ADDAC_Reverb_COG_ofs & $1FF '  COGSTART ADDAC_Reverb
                movd        __temp1,#ADDAC_Reverb_COG_ofs >> 9
                add         __temp1,par                     
                rdlong      __temp1,__temp1                 
                add         __temp1,#8                      
                coginit     __temp1                         

                mov         __temp1,#Compressor_COG_ofs & $1FF '  COGSTART Compressor
                movd        __temp1,#Compressor_COG_ofs >> 9
                add         __temp1,par                     
                rdlong      __temp1,__temp1                 
                add         __temp1,#8                      
                coginit     __temp1                         

                mov         __temp1,#Distortion_COG_ofs & $1FF '  COGSTART Distortion
                movd        __temp1,#Distortion_COG_ofs >> 9
                add         __temp1,par                     
                rdlong      __temp1,__temp1                 
                add         __temp1,#8                      
                coginit     __temp1                         

                mov         __temp1,#Echo_COG_ofs & $1FF     '  COGSTART Echo
                movd        __temp1,#Echo_COG_ofs >> 9      
                add         __temp1,par                     
                rdlong      __temp1,__temp1                 
                add         __temp1,#8                      
                coginit     __temp1                         


                                                             '  'COGSTART Gen_Sinus
__DO_1                                                       '  Do

                                                             '    'rdlong SampleNo,temp
                                                             '    'SerNumber temp
                                                             '    'rdlong debug,temp
                                                             '    'SerNumber temp
                mov         __temp1,__SSlot_ofs              '    rdlong sslot(0),temp
                add         __temp1,par                     
                add         __temp1,#(0 * 4)                
                rdlong      temp,__temp1                    

                mov         __param1,temp                    '    stars temp,4000
                mov         __param2,_4000                  
                call        #stars                          

                jmp         #__DO_1                          '  loop
__LOOP_1                                                    

                mov         __temp1,#0                       'End
                waitpne     __temp1,__temp1                 


SerNumber                                                    'SUB SerNumber

                mov         __temp1,#ascii                   '    STR ascii, __param1, 9,3
                mov         __temp2,__param1                
                mov         __temp4,#9-1                    
                mov         __temp3,#" "                    
                abs         __temp2,__temp2 WC              
                mov         __temp5,#" "                    
    IF_C        mov         __temp5,#"-"                    
                movd        $+2,__temp1                     
                add         __temp1,#1                      
                mov         0-0,__temp5                     
__L0001                                                     
                mov         __temp5,__temp3                 
__L0002                                                     
                cmpsub      __temp2,_10000000 WC, WR        
                cmp         __temp4,#1 WZ                   
    IF_C        mov         __temp3,#"0"                    
    IF_C_OR_Z   min         __temp5,#"0"                    
    IF_C        adds        __temp5,#1                      
    IF_C        jmp         #__L0002                        
                movd        $+2,__temp1                     
                add         __temp1,#1                      
                mov         0-0,__temp5                     
                mov         __temp5,__temp2                 
                shl         __temp2,#2                      
                add         __temp2,__temp5                 
                shl         __temp2,#1                      
                djnz        __temp4,#__L0001                

                mov         ascii+9,#13                      '    ascii(9) = 13

                mov         temp,#0                          '    FOR temp = 0 TO 9
__FOR_temp_1                                                

                mov         __temp1,TX                       '      SEROUT TX, Baud, ascii(temp)
                add         temp,#ascii                     
                movs        $+2,temp                        
                sub         temp,#ascii                     
                mov         __temp2,0-0                     
                or          __temp2,#256                    
                shl         __temp2,#1                      
                mov         __temp3,#10                     
                mov         __temp4,_115200baud             
                add         __temp4,cnt                     
                or          dira,__temp1                    
__L0003                                                     
                shr         __temp2,#1 WC                   
                muxc        outa,__temp1                    
                waitcnt     __temp4,_115200baud             
                djnz        __temp3,#__L0003                

                adds        temp,#1                          '    NEXT
                cmps        temp,#9 WZ, WC                  
    IF_BE       jmp         #__FOR_temp_1                   
__NEXT_temp_1                                               

SerNumber_ret                                                'ENDSUB
                ret                                         
                                                            


Stars                                                        'Sub Stars 'value + maxvalue as parameters

                mov         __temp1,__param1                 '   y = __param1 * amplchar
                mov         __temp2,amplchar                
                abs         __temp1,__temp1 WC              
                muxc        __temp3,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp3,#1                      
                mov         __temp4,#0                      
                mov         __temp5,#32                     
                shr         __temp1,#1 WC                   
__L0004                                                     
    IF_C        add         __temp4,__temp2 WC              
                rcr         __temp4,#1 WC                   
                rcr         __temp1,#1 WC                   
                djnz        __temp5,#__L0004                
                test        __temp3,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1 WZ              
    IF_NZ       sub         __temp4,#1                      
                mov         y,__temp1                       

                mov         __temp1,y                        '   y = y / __param2
                mov         __temp2,__param2                
                abs         __temp1,__temp1 WC              
                muxc        __temp5,#1                      
                abs         __temp2,__temp2 WC, WZ          
    IF_C        xor         __temp5,#1                      
                mov         __temp3,#0                      
__L0005                                                     
                add         __temp3,#1                      
                shl         __temp2,#1 WC                   
    IF_NC       jmp         #__L0005                        
                rcr         __temp2,#1                      
                mov         __temp4,#0                      
__L0006                                                     
                cmpsub      __temp1,__temp2 WC              
                rcl         __temp4,#1                      
                shr         __temp2,#1                      
                djnz        __temp3,#__L0006                
                test        __temp5,#1 WZ                   
    IF_NZ       neg         __temp4,__temp4                 
    IF_NZ       neg         __temp1,__temp1                 
                mov         y,__temp4                       

                                                             '   'y = y + amplchar
                mov         i,mamplchar                      '   for i = mamplchar to amplchar
__FOR_i_2                                                   

                                                             '      'sernumber i
                cmps        i,#0 WZ, WC                      '      if i=0 then
    IF_NZ       jmp         #__ELSE_1                       

                mov         __temp1,TX                       '                SEROUT TX, Baud, "+"
                mov         __temp2,#"+"                    
                or          __temp2,#256                    
                shl         __temp2,#1                      
                mov         __temp3,#10                     
                mov         __temp4,_115200baud             
                add         __temp4,cnt                     
                or          dira,__temp1                    
__L0007                                                     
                shr         __temp2,#1 WC                   
                muxc        outa,__temp1                    
                waitcnt     __temp4,_115200baud             
                djnz        __temp3,#__L0007                

                jmp         #__ENDIF_1                       '      elseif i=y then
__ELSE_1                                                    
                cmps        i,y WZ, WC                      
    IF_NZ       jmp         #__ELSE_2                       

                mov         __temp1,TX                       '                SEROUT TX, Baud, "*"
                mov         __temp2,#"*"                    
                or          __temp2,#256                    
                shl         __temp2,#1                      
                mov         __temp3,#10                     
                mov         __temp4,_115200baud             
                add         __temp4,cnt                     
                or          dira,__temp1                    
__L0008                                                     
                shr         __temp2,#1 WC                   
                muxc        outa,__temp1                    
                waitcnt     __temp4,_115200baud             
                djnz        __temp3,#__L0008                

                jmp         #__ENDIF_1                       '      else
__ELSE_2                                                    

                mov         __temp1,TX                       '                SEROUT TX, Baud, " "
                mov         __temp2,#" "                    
                or          __temp2,#256                    
                shl         __temp2,#1                      
                mov         __temp3,#10                     
                mov         __temp4,_115200baud             
                add         __temp4,cnt                     
                or          dira,__temp1                    
__L0009                                                     
                shr         __temp2,#1 WC                   
                muxc        outa,__temp1                    
                waitcnt     __temp4,_115200baud             
                djnz        __temp3,#__L0009                

__ENDIF_1                                                    '      endif

                adds        i,#1                             '   next i
                cmps        i,amplchar WZ, WC               
    IF_BE       jmp         #__FOR_i_2                      
__NEXT_i_2                                                  

                mov         __temp1,TX                       '   SEROUT TX, Baud, 13
                mov         __temp2,#13                     
                or          __temp2,#256                    
                shl         __temp2,#1                      
                mov         __temp3,#10                     
                mov         __temp4,_115200baud             
                add         __temp4,cnt                     
                or          dira,__temp1                    
__L0010                                                     
                shr         __temp2,#1 WC                   
                muxc        outa,__temp1                    
                waitcnt     __temp4,_115200baud             
                djnz        __temp3,#__L0010                

Stars_ret                                                    'ENDSUB
                ret                                         
                                                            





                                                             ''##############################################################################################
'**********************************************************************
__InitDirA       LONG %01000000_10111111_00001110_00000000
__InitOutA       LONG %01000000_00000000_00000000_00000000
_minus4000      
MaxNegAmpl       LONG -4000
MicFB            LONG 1 << 8
MicOut           LONG 1 << 9
_115200baud      LONG 694
RightChan        LONG 1 << 10
LeftChan         LONG 1 << 11
RBUFLEN         
_2500            LONG 2_500
MaxAmpl         
_4000            LONG 4000
AMPLITUDE       
_4096            LONG 4096
EBufLen         
_7000            LONG 7_000
ADCVALUE        
_8192            LONG 8192
__SSlot_ofs      LONG SSlot_ofs
LEDs             LONG 63 << 16
LED1             LONG 1 << 23
_10000000        LONG 10000000
_FREQ            LONG 80000000
TX               LONG 1 << 30

amplchar         LONG 40
mamplchar        LONG -40

__remainder
__temp1          RES 1
__temp2          RES 1
__temp3          RES 1
__temp4          RES 1
__temp5          RES 1
__param1         RES 1
__param2         RES 1
__param3         RES 1
__param4         RES 1
__paramcnt       RES 1
temp             RES 1
ascii            RES 13
i                RES 1
y                RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  POSFB                            = 72
  SinLen                           = 35
  ConSt2                           = 2
  EBuf_ofs                         = 0
  RBuf_ofs                         = 14000
  SSlot_ofs                        = 19000
  SampleNo_ofs                     = 19016
  debug_ofs                        = 19020
  SINTAB_ofs                       = 19024
  ADDAC_Reverb_COG_ofs             = 19096
  Gen_Sinus_COG_ofs                = 19100
  Distortion_COG_ofs               = 19104
  Compressor_COG_ofs               = 19108
  Echo_COG_ofs                     = 19112

' TASK Echo                                                  'TASK Echo









                                                             ''##############################################################################################

' TASK Compressor                                            'TASK Compressor











                                                             ''##############################################################################################

' TASK Distortion                                            'TASK Distortion





                                                             ''##############################################################################################

' TASK Gen_Sinus ' Generates a sin wave instead of the sample input 'TASK Gen_Sinus ' Generates a sin wave instead of the sample input



                                                             ''##############################################################################################

' TASK ADDAC_Reverb                                          'TASK ADDAC_Reverb





                                                             ''FUNC ECHOSOUND
                                                             ''      PutBuffer sample1
                                                             ''      'RDBYTE wavAddr, sample   ' Get a sample
                                                             ''      sample1= GetBuffer
                                                             ''      sample1 = sample1 << 19    ' Convert 13-bit sample to 32-bit value
                                                             ''      FRQB = sample1            ' Output sample
                                                             ''      return 0
                                                             ''ENDFUNC
                                                             ''FUNC GetBuffer
                                                             ''  rdword EBuf(rdpoint),__param1
                                                             ''  inc rdpoint
                                                             ''  if rdpoint = EBufLen then
                                                             ''    rdpoint= 0
                                                             ''  endif
                                                             ''  return __param1
                                                             ''ENDFUNC


                                                             ''##############################################################################################
                                                             ''TASK ADDAC_Reverb

                                                             '' Define variables (LONGs only)


                                                             '' Define Subroutines


                                                             '' Start of Task Code

                                                             '' Subroutine Code

                                                             ''ENDTASK


DAT
__DATASTART
EBuf             WORD 0[7000]
RBuf             WORD 0[2500]
SSlot            WORD 0[8]
SampleNo         LONG 0
debug            LONG 0
SINTAB
                 WORD 0 ,       695     ,       1368    ,       2000    ,       2571    ,       3064    ,       3464    ,       3759    ,       3939 
                 WORD 4000      ,       3939    ,       3759    ,       3464    ,       3064    ,       2571    ,       2000    ,       1368    ,       695 
                 WORD 0 ,       -695    ,       -1368   ,       -2000   ,       -2571   ,       -3064   ,       -3464   ,       -3759   ,       -3939 
                 WORD -4000     ,       -3939   ,       -3759   ,       -3464   ,       -3064   ,       -2571   ,       -2000   ,       -1368   ,       -695 
ADDAC_Reverb_COG LONG 0
Gen_Sinus_COG    LONG 0
Distortion_COG   LONG 0
Compressor_COG   LONG 0
Echo_COG         LONG 0
